import { Particle } from "../Particle";
import { FunctionJSON } from "../functions/FunctionJSON";
import { Constructable } from "../TypeUtil";
export interface Behavior {
    type: string;
    initialize(particle: Particle): void;
    update(particle: Particle, delta: number): void;
    toJSON(): any;
    clone(): Behavior;
}
export declare const BehaviorTypes: Array<Array<(string | Constructable<Behavior> | string[][])>>;
export declare function BehaviorFromJSON(json: {
    type: string;
    direction?: Array<number>;
    func: FunctionJSON;
}): Behavior;
